/********************************** (C) COPYRIGHT *******************************
CH552T  ն˳
2022/07/20
*******************************************************************************/

#include "CH554.H"                                                      
#include "DEBUG.H"
#include"GPIO.H"
#include"HIDDescriptor.h"
#include "SI24R1.h"
//#include"GPIO.H"
#include <string.h>
#include <stdio.h>
sbit LED = P3 ^ 0;
sbit test = P3 ^ 1;
sbit shockEN= P1 ^ 3;

bit IRQflag = 0;
#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE

UINT8X  Ep0Buffer[8 < (THIS_ENDP0_SIZE + 2) ? 8 : (THIS_ENDP0_SIZE + 2)] _at_ 0x0000;    //˵0 OUT&INżַ
UINT8X  Ep1Buffer[130] _at_ 0x000a;  //˵1 IN,żַ
UINT8   SetupReq,SetupLen,Ready,Count,FLAG,UsbConfig,LED_VALID;
PUINT8  pDescr;   //USBñ־
USB_SETUP_REQ   SetupReqBuf;  //ݴSetup
bit Ep2InKey;
#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)
#define DEBUG 0
#pragma  NOAREGS

/*HIDϱ*/
unsigned char HIDbuff[8] = {0};

/*******************************************************************************
* Function Name  : USBDeviceInit()
* Description    : USB豸ģʽ,豸ģʽշ˵ãжϿ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceInit()
{
	IE_USB = 0;
	USB_CTRL = 0x00; //USBƼĴ

    UDEV_CTRL &= ~bUD_LOW_SPEED;//ѡȫ12MģʽĬϷʽ
    UEP0_DMA = Ep0Buffer; //˵0ݴַ
    UEP1_DMA = Ep1Buffer; //˵1ݴַ
    //UEP4_1_MOD = ~(bUEP4_RX_EN | bUEP4_TX_EN | bUEP1_RX_EN | bUEP1_BUF_MOD) | bUEP4_TX_EN | bUEP1_RX_EN;//˵164ֽշ,˵0շ
    UEP4_1_MOD &= ~(bUEP4_RX_EN | bUEP4_TX_EN);//˵064ֽշ
    UEP4_1_MOD |= bUEP1_RX_EN;
    UEP4_1_MOD |= bUEP1_TX_EN;
    UEP4_1_MOD &= ~bUEP1_BUF_MOD;//˵1շ64ֽڻ
    
	UEP2_3_MOD = UEP2_3_MOD & ~bUEP2_BUF_MOD | bUEP2_TX_EN;
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK; //OUT񷵻ACKIN񷵻NAK
    //UEP1_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK; //˵1Զתͬ־λIN񷵻NAK OUTACK
    UEP1_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK; //˵1Զתͬ־λIN񷵻ACK OUTACK
    //UEP1_CTRL = bUEP_T_TOG | UEP_T_RES_NAK;	//˵1ֶתͬ־λIN񷵻NAK
	UEP2_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK; //˵2Զתͬ־λIN񷵻NAK
		
	  USB_DEV_AD = 0x00;
	  UDEV_CTRL = bUD_PD_DIS; // ֹDP/DM
	  USB_CTRL = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN; // USB豸DMAжڼжϱ־δǰԶNAK
	  UDEV_CTRL |= bUD_PORT_EN; // USB˿
	  USB_INT_FG = 0xFF; // жϱ־
	  USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
	  IE_USB = 1;
}
/*******************************************************************************
* Function Name  : Enp1IntIn()
* Description    : USB豸ģʽ˵1жϴ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void Enp1IntIn()
{
    memcpy( Ep1Buffer+64, HIDbuff, sizeof(HIDbuff)); //ϴ
    UEP1_T_LEN = sizeof(HIDbuff); //ϴݳ
    UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK; //ʱϴݲӦACK
}
/*******************************************************************************
* Function Name  : DeviceInterrupt()
* Description    : CH559USBжϴ
*******************************************************************************/
void    DeviceInterrupt(void) interrupt INT_NO_USB using 1                      //USBжϷ,ʹüĴ1
{
    UINT8 len;
    if (UIF_TRANSFER)                                                            //USBɱ־
    {
        switch (USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
        {
        case UIS_TOKEN_IN | 2:                                                  //endpoint 2# ж϶˵ϴ
            UEP2_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
//            UEP1_CTRL ^= bUEP_T_TOG;                                          //ԶתҪֶת
            UEP2_CTRL = UEP2_CTRL & ~MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            FLAG = 1; 															/*ɱ־*/
            break;
        case UIS_TOKEN_OUT | 2:                                                 //endpoint 2# ˵´
            if (U_TOG_OK)                                                     // ͬݰ
            {
                //˵2´ҪִɶԼд
            }
            break;
        case UIS_TOKEN_IN | 1:                                                  //endpoint 1# ж϶˵ϴ
            UEP1_T_LEN = 0;                                                     //Ԥʹ÷ͳһҪ
//            UEP2_CTRL ^= bUEP_T_TOG;                                          //ԶתҪֶת
            UEP1_CTRL = UEP1_CTRL & ~MASK_UEP_T_RES | UEP_T_RES_NAK;           //ĬӦNAK
            FLAG = 1;                                                           /*ɱ־*/
            break;
        case UIS_TOKEN_OUT | 1:                                                 //endpoint 2# ˵´
            if (U_TOG_OK)                                                     // ͬݰ
            {
                //˵1´ҪִɶԼд
            }
            break;
        case UIS_TOKEN_SETUP | 0:                                                //SETUP
            len = USB_RX_LEN;
            if (len == (sizeof(USB_SETUP_REQ)))
            {
                SetupLen = UsbSetupBuf->wLengthL;
                if (UsbSetupBuf->wLengthH || SetupLen > 0x7F)
                {
                    SetupLen = 0x7F;    // ܳ
                }
                len = 0;                                                        // ĬΪɹϴ0
                SetupReq = UsbSetupBuf->bRequest;
                if ((UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK) != USB_REQ_TYP_STANDARD)/* HID */
                {
                    switch (SetupReq)
                    {
                    case 0x01://GetReport
                        break;
                    case 0x02://GetIdle
                        break;
                    case 0x03://GetProtocol
                        break;
                    case 0x09://SetReport										
                        break;
                    case 0x0A://SetIdle
                        break;
                    case 0x0B://SetProtocol
                        break;
                    default:
                        len = 0xFF;  								 					            /*֧*/
                        break;
                    }
                }
                else
                {//׼
                    switch (SetupReq)                                        //
                    {
                    case USB_GET_DESCRIPTOR:
                        switch (UsbSetupBuf->wValueH)
                        {
                        case 1:                                             //豸
                            pDescr = DevDesc;                               //豸͵Ҫ͵Ļ
                            len = sizeof(DevDesc);
                            break;
                        case 2:                                             //
                            pDescr = CfgDesc;                               //豸͵Ҫ͵Ļ
                            len = sizeof(CfgDesc);
                            break;
                        case 0x22:                                          //
                            if (UsbSetupBuf->wIndexL == 0)                   //ӿ0
                            {
                                pDescr = RepDesc;                        //׼ϴ
                                len = sizeof(RepDesc);
                                Ready = 1;
                            }               
                            else
                            {
                                len = 0xff;                                 //ֻ2ӿڣ仰ִ
                            }
                            break;
                        default:
                            len = 0xff;                                     //ֵ֧߳
                            break;
                        }
                        if (SetupLen > len)
                        {
                            SetupLen = len;    //ܳ
                        }
                        len = SetupLen >= 8 ? 8 : SetupLen;                  //δ䳤
                        memcpy(Ep0Buffer, pDescr, len);                        //ϴ
                        SetupLen -= len;
                        pDescr += len;
                        break;
                    case USB_SET_ADDRESS:
                        SetupLen = UsbSetupBuf->wValueL;                     //ݴUSB豸ַ
                        break;
                    case USB_GET_CONFIGURATION:
                        Ep0Buffer[0] = UsbConfig;
                        if (SetupLen >= 1)
                        {
                            len = 1;
                        }
                        break;
                    case USB_SET_CONFIGURATION:
                        UsbConfig = UsbSetupBuf->wValueL;
                        break;
                    case 0x0A:
                        break;
                    case USB_CLEAR_FEATURE:                                            //Clear Feature
                        if ((UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK) == USB_REQ_RECIP_ENDP)// ˵
                        {
                            switch (UsbSetupBuf->wIndexL)
                            {
                            case 0x82:
                                UEP2_CTRL = UEP2_CTRL & ~(bUEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                                break;
                            case 0x81:
                                UEP1_CTRL = UEP1_CTRL & ~(bUEP_T_TOG | MASK_UEP_T_RES) | UEP_T_RES_NAK;
                                break;
                            case 0x01:
                                UEP1_CTRL = UEP1_CTRL & ~(bUEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                                break;
                            case 0x02:
                                UEP2_CTRL = UEP2_CTRL & ~(bUEP_R_TOG | MASK_UEP_R_RES) | UEP_R_RES_ACK;
                                break;
                            default:
                                len = 0xFF;                                            // ֵ֧Ķ˵
                                break;
                            }
                        }
                        else
                        {
                            len = 0xFF;                                                // Ƕ˵㲻֧
                        }
                        break;
                    case USB_SET_FEATURE:                                              /* Set Feature */
                        if ((UsbSetupBuf->bRequestType & 0x1F) == 0x00)             /* 豸 */
                        {
                            if ((((UINT16)UsbSetupBuf->wValueH << 8) | UsbSetupBuf->wValueL) == 0x01)
                            {
                                if (CfgDesc[7] & 0x20)
                                {
                                    /* ûʹܱ־ */
                                }
                                else
                                {
                                    len = 0xFF;                                        /* ʧ */
                                }
                            }
                            else
                            {
                                len = 0xFF;                                            /* ʧ */
                            }
                        }
                        else if ((UsbSetupBuf->bRequestType & 0x1F) == 0x02)        /* ö˵ */
                        {
                            if ((((UINT16)UsbSetupBuf->wValueH << 8) | UsbSetupBuf->wValueL) == 0x00)
                            {
                                switch (((UINT16)UsbSetupBuf->wIndexH << 8) | UsbSetupBuf->wIndexL)
                                {
                                case 0x82:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵2 IN STALL */
                                    break;
                                case 0x02:
                                    UEP2_CTRL = UEP2_CTRL & (~bUEP_R_TOG) | UEP_R_RES_STALL;/* ö˵2 OUT Stall */
                                    break;
                                case 0x81:
                                    UEP1_CTRL = UEP1_CTRL & (~bUEP_T_TOG) | UEP_T_RES_STALL;/* ö˵1 IN STALL */
                                    break;
                                default:
                                    len = 0xFF;                               //ʧ
                                    break;
                                }
                            }
                            else
                            {
                                len = 0xFF;                                   //ʧ
                            }
                        }
                        else
                        {
                            len = 0xFF;                                      //ʧ
                        }
                        break;
                    case USB_GET_STATUS:
                        Ep0Buffer[0] = 0x00;
                        Ep0Buffer[1] = 0x00;
                        if (SetupLen >= 2)
                        {
                            len = 2;
                        }
                        else
                        {
                            len = SetupLen;
                        }
                        break;
                    default:
                        len = 0xff;                                           //ʧ
                        break;
                    }
                }
            }
            else
            {
                len = 0xff;                                                   //ȴ
            }
            if (len == 0xff)
            {
                SetupReq = 0xFF;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL
            }
            else if (len <= 8)                                                //ϴݻ״̬׶η0Ȱ
            {
                UEP0_T_LEN = len;
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1ӦACK
            }
            else
            {
                UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA1,ӦACK
            }
            break;
        case UIS_TOKEN_IN | 0:                                               //endpoint0 IN
            switch (SetupReq)
            {
            case USB_GET_DESCRIPTOR:
                len = SetupLen >= 8 ? 8 : SetupLen;                          //δ䳤
                memcpy(Ep0Buffer, pDescr, len);                            //ϴ
                SetupLen -= len;
                pDescr += len;
                UEP0_T_LEN = len;
                UEP0_CTRL ^= bUEP_T_TOG;                                     //ͬ־λת
                break;
            case USB_SET_ADDRESS:
                USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            default:
                UEP0_T_LEN = 0;                                              //״̬׶жϻǿϴ0ݰƴ
                UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                break;
            }
            break;
        case UIS_TOKEN_OUT | 0:  // endpoint0 OUT
            len = USB_RX_LEN;
            if ((SetupReq == 0x09) && (len == 1))
            {
                LED_VALID = Ep0Buffer[0];
            }
            else if ((SetupReq == 0x09) && (len == 8)) {//SetReport						 
            }
            UEP0_T_LEN = 0;  //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
            UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_ACK;//ĬݰDATA0,ӦACK
            break;
        default:
            break;
        }
        UIF_TRANSFER = 0;                                                 //д0ж
    }
    if (UIF_BUS_RST)                                                       //豸ģʽUSB߸λж
    {
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK;
        UEP2_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                                 //жϱ־
    }
    if (UIF_SUSPEND)                                                     //USB߹/
    {
        UIF_SUSPEND = 0;
    }
    else {                                                               //ж,ܷ
        USB_INT_FG = 0xFF;                                               //жϱ־
    }
}
/* ⲿж0 */
void INT0Interrupt(void) interrupt INT_NO_INT0
{
    IRQflag = 1;
}

/*****************************************************************/
void main()
{
    unsigned char cnt = 0;
    unsigned char xdata rxBuf[32] = { 0 };

    CfgFsys(); //CH552ʱѡ12M
    mDelaymS(5); //޸Ƶȴڲȶ,ؼ	
	USBDeviceInit(); //USB豸ģʽʼ
    IT0 = 1;//ʹINT0½ж
    EX0 = 1;//ʹINT0ж
    EA = 1; //Ƭж
    UEP1_T_LEN = 0; //Ԥʹ÷ͳһҪ
  	UEP2_T_LEN = 0;	//ն˵2ͳ
    FLAG = 0; //USBжϴɱ־
    Ready = 0;
    //P1.3 P3.0ó
    P1_MOD_OC = P1_MOD_OC & ~(1 << 3);
    P1_DIR_PU = P1_DIR_PU | (1 << 3);
    P3_MOD_OC = P3_MOD_OC & ~(1 << 0);
    P3_DIR_PU = P3_DIR_PU | (1 << 0);

    P3_MOD_OC = P3_MOD_OC & ~(1 << 1);
    P3_DIR_PU = P3_DIR_PU | (1 << 1);
    mDelaymS(100);

    test = 1;
    LED = 0;
    shockEN = 1;
    mDelaymS(1000);
    LED = 1;
    shockEN = 0;

    memset(Ep1Buffer, 0, 130);
    //SI24R1_Init();
    //SI24R1_RX_Mode();
    HIDbuff[0] = 0x66;
    Enp1IntIn();
    HIDbuff[0] = 0;
    mDelaymS(50);
    HIDbuff[0] = 0x67;
    Enp1IntIn();
    HIDbuff[0] = 0;
    mDelaymS(20);
    while (1)
    {     
        if (test == 0)
        {
            LED = ~LED;
            //IRQflag = 0;
            //SI24R1_RxPacket(rxBuf);
            HIDbuff[0] = 0x22;
            HIDbuff[1] = 1;
            Enp1IntIn();
            HIDbuff[0] = 0;
            HIDbuff[1] = 0;
            mDelaymS(1000);
        }
        mDelaymS(100);
    }
}
/*
if (test == 0)
        {
            LED = ~LED;
            //IRQflag = 0;
            //SI24R1_RxPacket(rxBuf);
            HIDbuff[0] = 0x22;
            HIDbuff[1] = 1;
            Enp1IntIn();
            HIDbuff[0] = 0;
            HIDbuff[1] = 0;
            mDelaymS(1000);
        }
        mDelaymS(100);
*/
/*
if (IRQflag)
        {
            IRQflag = 0;
            SI24R1_RxPacket(rxBuf);
            HIDbuff[0] = 0x22;
            HIDbuff[1] = rxBuf[0];
            Enp1IntIn();
            HIDbuff[0] = 0;
            HIDbuff[1] = 0;
        }
        mDelaymS(200);
*/
/*
LED = ~LED;
        HIDbuff[0] = SI24R1_Read_Reg(STATUS);//ȡ״̬Ĵֵ
        SI24R1_Write_Reg(WRITE_REG + STATUS, HIDbuff[0]);//RX_DSжϱ־
        if (HIDbuff[0] & RX_DR)//յ
        {
            SI24R1_Read_Buf(RD_RX_PLOAD, rxBuf, TX_PLOAD_WIDTH);     //ȡ
            SI24R1_Write_Reg(FLUSH_RX, 0xff);//RX FIFOĴ
            HIDbuff[2] = 0x23;
            HIDbuff[3] = rxBuf[0];
        }
        if (IRQflag)
        {
            IRQflag = 0;
            HIDbuff[1] = 0x88;
        }
        Enp1IntIn();
        HIDbuff[0] = 0;
        HIDbuff[1] = 0;
        HIDbuff[2] = 0;
        HIDbuff[3] = 0;
        mDelaymS(2000);
*/